/*
Paros and its related class files.
Paros is an HTTP/HTTPS proxy for assessing web application security.
Copyright (C) 2003-2004 www.proofsecure.com

This program is free software; you can redistribute it and/or
modify it under the terms of the Clarified Artistic License
as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Clarified Artistic License for more details.

You should have received a copy of the Clarified Artistic License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
package com.proofsecure.paros.scan;

import java.io.IOException;
import java.net.URISyntaxException;

class TestStressURL extends AbstractAppTest {

	private int mCount = 0;
	
	public TestStressURL() {
	}
	
	public TestStressURL(int paramCount) {
		mCount = paramCount;
	}
	
	public String toString() {
        return "TestStressURL";
    }


	public String getTestName() {
		return "Stress test";
	}

	protected void scanTree(ParsedEntity entity) {
		for (int i=0; i<mCount && !isSignalStop(); i++) {
			scanOneNode(entity);
			if (i % 100 == 99) {
				writeOutput("Scanned " + (i+1) + " times...");
			}
		}
	}
	
	protected void scan() throws Exception {
		test();
	}


	private void test() throws URISyntaxException, IOException {
		sendAndReceive();
		close();
	}
	


}